      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      include 'PDFCOM.'

      real*8 q2hera(9),xmin(9),xmax(9)
      data q2hera/ 3d2, 5d2, 1d3, 1.5d3, 2d3, 3d3, 5d3, 8d3, 1.5d4/ 

      data xmin/ 8d-3, 1.3d-2, 1.3d-2, 3.2d-2, 3.2d-2, 8d-2, 8d-2, 
     ,           0.13d0, 0.32d0/

      data xmax/ 8d-2, 0.13d0, 0.25d0, 0.25d0, 0.25d0, 0.4d0, 0.4d0, 
     ,           0.4d0, 0.4d0/

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2
      call pdffillgrid

!  Set the factorization scale as sqrt(Q2*hqscale1 + m^2*hqscale2) for the 
!  single heavy-quark production
      hqscale1=1d0
      hqscale2=1d0

!  NNLO approximation for the light-flavour contribution
      kordf2=2
      kordfl=3
      kordf3=2

!  NLO approximation for the heavy-quark contribution
      kordhq=1

      msbarm=.true.
! Set the c-quark mass at the value obtained in [arXiv:1011.5790]
      rmass(8)=1.175

      print *,'The light-flavor contribution to the', 
     -' DIS CC structure functions up to the NNLO',
     -' (first column: the momentum transferred squared, the second',
     -' column: the value of Bjorken,',
     -' variable x, the third column: F_2(W+ current),', 
     -' the 4-th column: xF_3(W+ current),', 
     -' the 5-th column: F_L(W+ current)', 
     -' the 6-th column: F_2(W- current),', 
     -' the 7-th column: xF_3(W- current),', 
     -' the 8-th column: F_L(W- current)' 

      do kk=1,9
        q2=q2hera(kk)
        bmin=xmin(kk)
        bmax=xmax(kk)
        nbin=10
        bin=(log(bmax)-log(bmin))/(nbin-1)

        do nn=1,nbin
          xb=bmin*exp(bin*(nn-1))
          a1=f2qcd(6,1,24,xb,q2)
          a2=xb*f3qcd(6,1,24,xb,q2)
          a3=flqcd(6,1,24,xb,q2)
          a4=f2qcd(7,1,24,xb,q2)
          a5=xb*f3qcd(7,1,24,xb,q2)
          a6=flqcd(7,1,24,xb,q2)

          write (*,fmt='(10e13.4)') q2,xb,a1,a2,a3,a4,a5,a6
        end do
      end do 

      print *,'The c-quark contribution to the', 
     -' DIS CC structure functions in the running-mass definition',
     -' up to the NLO',
     -' (first column: the momentum transferred squared, the second',
     -' column: the value of Bjorken,',
     -' variable x, the third column: F_2(W+ current),', 
     -' the 4-th column: xF_3(W+ current),', 
     -' the 5-th column: F_L(W+ current)', 
     -' the 6-th column: F_2(W- current),', 
     -' the 7-th column: xF_3(W- current),', 
     -' the 8-th column: F_L(W- current)' 

      do kk=1,9
        q2=q2hera(kk)
        bmin=xmin(kk)
        bmax=xmax(kk)
        nbin=10
        bin=(log(bmax)-log(bmin))/(nbin-1)

        do nn=1,nbin
          xb=bmin*exp(bin*(nn-1))
          a1=f2nucharm(6,1,24,xb,q2,8)
          a2=xb*f3nucharm(6,1,24,xb,q2,8)
          a3=f2nucharm(6,1,24,xb,q2,8)-ftnucharm(6,1,24,xb,q2,8)
          a4=f2nucharm(7,1,24,xb,q2,8)
          a5=xb*f3nucharm(7,1,24,xb,q2,8)
          a6=f2nucharm(7,1,24,xb,q2,8)-ftnucharm(7,1,24,xb,q2,8)

          write (*,fmt='(10e13.4)') q2,xb,a1,a2,a3,a4,a5,a6
        end do
      end do 

      stop
      end
