      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      include 'PDFCOM.'

      real*8 termplus(20,20,0:50,100),termtotplus(20,20,0:50,100)
     ,      ,termdisp(20,20,100)

      real*8 xbnutev(4)
      data xbnutev/ 0.021d0, 0.057d0, 0.1d0, 0.17d0/

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2

! NNLO for the massless Wilson coefficients
      kordf2=2
      kordfl=3
      kordf3=2

! Weak-mixing angle sine squared (PDG 2010)
      sintw2=0.23116d0
! Z-boson mass (PDG 2010)
      rmassp(41)=91.1876
! W-boson mass (PDG 2010)
      rmassp(42)=80.358
! Fermi constant
      gfer=1.16637d-5
! Conversion constant
      gev2mbarn=0.3893857d0
! Typical s.c.m. energy of the NUTEV experiment
      ecm=30.

      nbin=30
      do kpdfset=0,npdftot
        call pdffillgrid  
        do kk=1,4
          xb=xbnutev(kk)
          bmin=3d0
          bmax=xb*ecm**2
          bin=(log(bmax)-log(bmin))/(nbin-1)
          do klum=1,4
            do nn=1,nbin
              q2=bmin*exp(bin*(nn-1))
              yb=q2/(ecm)**2/xb
              yplus=(1+(1-yb)**2)/2.
              yminus=(1-(1-yb)**2)/2.
              zsup=gfer**2*ecm**2/pi/2./(1.+q2/rmassp(41)**2)**2
     *     *gev2mbarn*1d9
              wsup=gfer**2*ecm**2/pi/2./(1.+q2/rmassp(42)**2)**2
     *     *gev2mbarn*1d9
! neutrino-proton scattering
              sigznu=(yplus*f2qcd(6,1,23,xb,q2)
     -    -  yb**2/2.*flqcd(6,1,23,xb,q2)
     +    +  yminus*xb*f3qcd(6,1,23,xb,q2))*zsup
! anti-neutrino proton scattering
              sigznub=(yplus*f2qcd(7,1,23,xb,q2)
     -    -  yb**2/2.*flqcd(7,1,23,xb,q2)
     -    -  yminus*xb*f3qcd(7,1,23,xb,q2))*zsup
! neutrino-neutron scattering
              sigznun=(yplus*f2qcd(6,8,23,xb,q2)
     -    -  yb**2/2.*flqcd(6,8,23,xb,q2)
     +    +  yminus*xb*f3qcd(6,8,23,xb,q2))*zsup
! anti-neutrino neutron scattering
              sigznubn=(yplus*f2qcd(7,8,23,xb,q2)
     -    -  yb**2/2.*flqcd(7,8,23,xb,q2)
     -    -  yminus*xb*f3qcd(7,8,23,xb,q2))*zsup

              if (klum.eq.1) termplus(klum,kk,kpdfset,nn)=sigznu
              if (klum.eq.2) termplus(klum,kk,kpdfset,nn)=sigznub
              if (klum.eq.3) termplus(klum,kk,kpdfset,nn)=sigznun
              if (klum.eq.4) termplus(klum,kk,kpdfset,nn)=sigznubn
           end do
          end do
        end do
      end do

      print *,'The neutral-current inclusive DIS cross section', 
     -' d(sig)/d(x)/d(y) (pb)',
     -' in the NNLO QCD approximation for different beam and target',
     -' combinations at the c.m.s. energy of 30 GeV and representative',
     -' kinematics of the NuTeV experiment',
     -' (first column: the value of Bjorken variable x, the second',
     -' column: the momentum transferred squared (GeV^2),', 
     -' the third column: neutrino-proton c.s.,',
     -' the 4-th column: antineutrino-proton c.s.,',
     -' the 5-th column: neutrino-neutron c.s.',
     -' the 6-th column: antineutrino-neutron c.s.)'

      do kk=1,4
        xb=xbnutev(kk)
        bmin=3d0
        bmax=xb*ecm**2
        bin=(log(bmax)-log(bmin))/(nbin-1)
        do i=1,nbin
          q2=bmin*exp(bin*(i-1))
          do klum=1,4
            termdisp(klum,1,i)=0.
            do kpdfset=1,npdftot          
              termdisp(klum,kk,i)=termdisp(klum,kk,i)
     +       +(termplus(klum,kk,kpdfset,i)-termplus(klum,kk,0,i))**2
            enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#if defined(ABKM09) || defined(ABKM09M) || defined(ABM11)
          termdisp(klum,kk,i)=sqrt(termdisp(klum,kk,i))
#else
          termdisp(klum,kk,i)=sqrt(termdisp(klum,kk,i)/2.)
#endif

          end do
        write (*,fmt='(2e13.4,6(e13.4,a2,e10.4))') xb,q2
     ,        ,(termplus(ll,kk,0,i),'+-',termdisp(ll,kk,i),ll=1,4)
        end do
      end do

      stop
      end
