      implicit real*8 (a-h,o-z)

      INCLUDE 'CONSTCOM.'
      INCLUDE 'PDFCOM.'

      real*8 termplus(10,0:50,100),termtotplus(10,0:50,100)
     ,      ,termdisp(10,100)
      real*8 qmom(5)
      data qmom /2d0, 4d0, 6d0, 8d0, 10d0/
      external uvdvmomi,udmomi,udsmomi

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs
      kschemepdf=0
      kordpdf=2
 
      print *,npdftot
      do kpdfset=0,npdftot
!  Fill the PDF grid for the set #kpdfset

        call pdffillgrid

        do i=1,5
!  Fill the average momenta of the quark isospin asymmetries
          termplus(1,kpdfset,i)=pdfmom(1,qmom(i)**2,uvdvmomi)
          termplus(2,kpdfset,i)=pdfmom(1,qmom(i)**2,udmomi)
          termplus(3,kpdfset,i)=pdfmom(1,qmom(i)**2,udsmomi)
        end do
      end do

      print *,' The first moments (average momentum)',
     -' of the quark distribution asymmetries',
     -' (first column: factorization scale in GeV^2,',
     -' second column: (u_V-d_V),',
     -' third column: (u+ubar-d-dbar),',
     -' 4-th column: [u+ubar+d+dbar-2(s+sbar)] ).'

      do i=1,5

        do klum=1,3
          termdisp(klum,i)=0.

          do kpdfset=1,npdftot          
            termdisp(klum,i)=termdisp(klum,i)
     +    +(termplus(klum,kpdfset,i)-termplus(klum,0,i))**2
          enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#if defined(ABKM09) || defined(ABKM09M)
!  Symmetric errors
          termdisp(klum,i)=sqrt(termdisp(klum,i))
#else
!  Asymmetric errors stored by pairs
          termdisp(klum,i)=sqrt(termdisp(klum,i)/2.)
#endif
        end do

        write (*,fmt='(e13.4,3(e13.4,a2,e10.4))') qmom(i)**2
     ,        ,termplus(1,0,i),'+-',termdisp(1,i)
     ,        ,termplus(2,0,i),'+-',termdisp(2,i)
     ,        ,termplus(3,0,i),'+-',termdisp(3,i)
      end do

      stop
      end
c-----------------------
      real*8 function pdfmom(n,q2,qmomi)
      implicit real*8 (a-h,o-z)

      common /forpdfmom/ q2rep,nmom
      external qmomi

      nmom=n-1
      q2rep=q2
      call gauss2(qmomi,log(1d-5),0d0,6,df,eps)
      pdfmom=df

      return
      end
c----------------------------
      real*8 function uvdvmomi(t)
      implicit real*8 (A-H,O-Z)

      INCLUDE 'PDFCOM.'

      common /forpdfmom/ q2rep,nmom
      xb=exp(t)

      uvdvmomi=(xqg(4,xb,q2rep,kschemepdf)-xqg(5,xb,q2rep,kschemepdf)
     -       -xqg(2,xb,q2rep,kschemepdf)+xqg(3,xb,q2rep,kschemepdf))
     *       *xb**(nmom+1)

      return
      end
c----------------------------
      real*8 function udmomi(t)
      implicit real*8 (A-H,O-Z)

      INCLUDE 'PDFCOM.'

      common /forpdfmom/ q2rep,nmom
      xb=exp(t)

      udmomi=(xqg(4,xb,q2rep,kschemepdf)+xqg(5,xb,q2rep,kschemepdf)
     -       -xqg(2,xb,q2rep,kschemepdf)-xqg(3,xb,q2rep,kschemepdf))
     *       *xb**(nmom+1)

      return
      end
c----------------------------
      real*8 function udsmomi(t)
      implicit real*8 (A-H,O-Z)

      INCLUDE 'PDFCOM.'

      common /forpdfmom/ q2rep,nmom
      xb=exp(t)

      udsmomi=(xqg(4,xb,q2rep,kschemepdf)+xqg(5,xb,q2rep,kschemepdf)
     +       +xqg(2,xb,q2rep,kschemepdf)+xqg(3,xb,q2rep,kschemepdf)
     -       -2*(xqg(6,xb,q2rep,kschemepdf)+xqg(7,xb,q2rep,kschemepdf)))
     *       *xb**(nmom+1)

      return
      end
